from schematics.models import Model
from schematics.types import StringType


class ExportRequest(Model):
    """Schema for Export object."""
    user = StringType(
        required=True,
        min_length=1,
        metadata={
            'description': 'The username of the user that '
            'started the export.'}
    )
    export_type = StringType(
        required=True,
        choices=['full_export', 'user_export'],
        metadata={
            'description': 'What type of export is being '
            'performed, full or user export'}
    )
