from schematics.models import Model
from schematics.types import StringType, IntType


class ExportsFetch(Model):
    """Schema for ExportFetch request."""
    limit = IntType(
        required=False,
        min_value=1,
        metadata={
            'description': 'Limit of how many exports should be returned'}
    )
    sort_by = StringType(
        required=False,
        choices=['id', 'creation_time', 'status',
                 'user', 'export_type', 'details'],
        metadata={
            'description': 'What property the exports should be sorted on'}
    )
    order = StringType(
        required=False,
        choices=['asc', 'desc'],
        metadata={
            'description': 'The sort order of the exports'}
    )
