from schematics.models import Model
from schematics.types import StringType, ModelType


class ExportStep(Model):
    """ Schema to describe a step in the export process """
    state = StringType(
        required=True,
        choices=['pending', 'running', 'success', 'fail', 'skip'],
        default='pending',
        metadata={'state': 'Which state the step is in'})
    details = StringType(
        required=True,
        default='',
        metadata={'details': 'Details about step'})


class ExportDetails(Model):
    """ Schema for the step details of an export """
    backup = ModelType(ExportStep, default=ExportStep())
    commit = ModelType(ExportStep, default=ExportStep())
    verify = ModelType(ExportStep, default=ExportStep())
    reload = ModelType(ExportStep, default=ExportStep())
    rollback = ModelType(ExportStep, default=ExportStep())
