from oslo_config import cfg
from oslo_db import api as db_api


_BACKEND_MAPPING = {'sqlalchemy': 'nachos.db.sqlalchemy.api'}

# Initialize an instance of DBAPI
# This will import nachos.db.sqlalchemy.api
IMPL = db_api.DBAPI.from_config(cfg.CONF, backend_mapping=_BACKEND_MAPPING)


def get_engine():
    return IMPL.get_engine()


def get_session():
    return IMPL.get_session()


def db_sync(engine, version=None):
    """Migrate the database to `version` or the most recent version."""
    return IMPL.db_sync(engine, version=version)


def db_version(engine):
    """Display the current database version."""
    return IMPL.db_version(engine)


def export_get(export_id):
    return IMPL.export_get(export_id)


def export_get_all(limit=None, sort_by='creation_time', order='desc'):
    return IMPL.export_get_all(limit, sort_by, order)


def export_get_latest():
    return IMPL.export_get_latest()


def export_create(values):
    return IMPL.export_create(values)


def export_update(values):
    return IMPL.export_update(values)


def export_delete(values):
    return IMPL.export_delete(values)


def export_get_all_unfinished():
    return IMPL.export_get_all_unfinished()
