from nachos.nacoma.mappers import BaseCommandMapper
from nachos.engine.export.writers.helpers import write_property


def write_command(command, out):

    assert isinstance(command, BaseCommandMapper), \
        'Expected command parameter to implement BaseCommandMapper'

    assert command.command_name is not None, \
        'Command command_name cannot be None'

    assert type(command.command_name) == str, \
        'Command command_name must be a String'

    out.write("# command '{}'\n".format(command.command_name))
    out.write('define command {\n')

    write_property(out, 'command_name', command.command_name)
    write_property(out, 'command_line', command.command_line)

    out.write('}\n')
