from nachos.nacoma.mappers import BaseContactgroupMapper
from nachos.engine.export.writers.helpers import write_property, write_list


def write_contactgroup(contactgroup, out):

    assert isinstance(contactgroup, BaseContactgroupMapper), \
        'Expected contactgroup parameter to implement BaseContactgroupMapper'

    assert contactgroup.contactgroup_name is not None, \
        'Contactgroup contactgroup_name cannot be None'

    out.write("# contactgroup '{}'\n".format(contactgroup.contactgroup_name))
    out.write('define contactgroup {\n')

    write_property(out, 'contactgroup_name', contactgroup.contactgroup_name)
    write_property(out, 'alias', contactgroup.alias)
    write_list(out, 'contactgroup_members',
               contactgroup.contactgroup_members, 'contactgroup_name')

    out.write('}\n')
