from nachos.nacoma.mappers import BaseHostgroupMapper
from nachos.engine.export.writers.helpers import write_property, write_list


def write_hostgroup(hostgroup, out):

    assert isinstance(hostgroup, BaseHostgroupMapper), \
        'Expected hostgroup parameter to implement BaseHostgroupMapper'

    # If this is a template (register = 0) hostgroup_name and
    # address are not mandatory
    assert not (hostgroup.hostgroup_name is None
                and hostgroup.register != 0), \
        'Hostgroup hostgroup_name cannot be None'

    out.write("# hostgroup '{}'\n".format(hostgroup.hostgroup_name))
    out.write('define hostgroup {\n')
    write_property(out, 'hostgroup_name', hostgroup.hostgroup_name)
    write_property(out, 'alias', hostgroup.alias)
    write_list(out, 'hostgroup_members', hostgroup.hostgroup_members,
               'hostgroup_name')
    write_property(out, 'notes', hostgroup.notes)
    write_property(out, 'notes_url', hostgroup.notes_url)
    write_property(out, 'action_url', hostgroup.action_url)
    out.write('}\n')
