from nachos.nacoma.mappers import BaseServicegroupMapper
from nachos.engine.export.writers.helpers import (write_property,
                                                  write_list)


def write_servicegroup(servicegroup, out):

    assert isinstance(servicegroup, BaseServicegroupMapper), \
        'Expected servicegroup parameter to implement BaseServicegroupMapper'

    # If this is a template (register = 0) servicegroup_name and
    # address are not mandatory
    assert not (servicegroup.servicegroup_name is None
                and servicegroup.register != 0), \
        'Servicegroup servicegroup_name cannot be None'

    out.write("# servicegroup '{}'\n".format(servicegroup.servicegroup_name))
    out.write('define servicegroup {\n')
    write_property(out, 'servicegroup_name', servicegroup.servicegroup_name)
    write_property(out, 'alias', servicegroup.alias)
    write_list(out, 'servicegroup_members',
               servicegroup.servicegroup_members, 'servicegroup_name')
    write_property(out, 'notes', servicegroup.notes)
    write_property(out, 'notes_url', servicegroup.notes_url)
    write_property(out, 'action_url', servicegroup.action_url)
    out.write('}\n')
