from nachos.nacoma.mappers import BaseTimeperiodMapper
from nachos.engine.export.writers.helpers import write_property, write_list


def write_timeperiod(timeperiod, out):

    assert isinstance(timeperiod, BaseTimeperiodMapper), \
        'Expected timeperiod parameter to implement BaseTimeperiodMapper'

    # If this is a template (register = 0) timeperiod_name and
    # address are not mandatory
    assert timeperiod.timeperiod_name is not None, \
        'Timeperiod timeperiod_name cannot be None'

    out.write("# timeperiod '{}'\n".format(timeperiod.timeperiod_name))
    out.write('define timeperiod {\n')
    write_property(out, 'timeperiod_name', timeperiod.timeperiod_name)
    write_property(out, 'alias', timeperiod.alias)
    write_list(out, 'exclude', timeperiod.exclude, 'timeperiod_name')

    if timeperiod.weekdays is not None:
        for datetimerange in timeperiod.weekdays:
            write_property(out,
                           datetimerange.daterange,
                           datetimerange.timerange)

    if timeperiod.custom_vars is not None:
        for custom_var in timeperiod.custom_vars:
            write_property(out,
                           custom_var.key,
                           custom_var.value)

    out.write('}\n')
