from nachos.engine.export.writers.command import write_command
from nachos.engine.export.writers.contact import write_contact
from nachos.engine.export.writers.contactgroup import write_contactgroup
from nachos.engine.export.writers.host import write_host
from nachos.engine.export.writers.hostdependency import write_hostdependency
from nachos.engine.export.writers.hostescalation import write_hostescalation
from nachos.engine.export.writers.hostgroup import write_hostgroup
from nachos.engine.export.writers.service import write_service
from nachos.engine.export.writers.servicedependency import write_servicedependency  # noqa: E501
from nachos.engine.export.writers.serviceescalation import write_serviceescalation  # noqa: E501
from nachos.engine.export.writers.servicegroup import write_servicegroup
from nachos.engine.export.writers.timeperiod import write_timeperiod
from nachos.nacoma.mappers.base.command import BaseCommandMapper
from nachos.nacoma.mappers.base.contact import BaseContactMapper
from nachos.nacoma.mappers.base.contactgroup import BaseContactgroupMapper
from nachos.nacoma.mappers.base.host import BaseHostMapper
from nachos.nacoma.mappers.base.hostdependency import BaseHostdependencyMapper
from nachos.nacoma.mappers.base.hostescalation import BaseHostescalationMapper
from nachos.nacoma.mappers.base.hostgroup import BaseHostgroupMapper
from nachos.nacoma.mappers.base.service import BaseServiceMapper
from nachos.nacoma.mappers.base.servicedependency import BaseServicedependencyMapper  # noqa: E501
from nachos.nacoma.mappers.base.serviceescalation import BaseServiceescalationMapper  # noqa: E501
from nachos.nacoma.mappers.base.servicegroup import BaseServicegroupMapper
from nachos.nacoma.mappers.base.timeperiod import BaseTimeperiodMapper


def write_object(object, out):
    assert object is not None, 'write_object called without an object to write'
    assert out is not None, 'write_object called without a handle to write to'
    if isinstance(object, BaseCommandMapper):
        write_command(object, out)
    elif isinstance(object, BaseContactMapper):
        write_contact(object, out)
    elif isinstance(object, BaseContactgroupMapper):
        write_contactgroup(object, out)
    elif isinstance(object, BaseHostMapper):
        write_host(object, out)
    elif isinstance(object, BaseHostdependencyMapper):
        write_hostdependency(object, out)
    elif isinstance(object, BaseHostescalationMapper):
        write_hostescalation(object, out)
    elif isinstance(object, BaseHostgroupMapper):
        write_hostgroup(object, out)
    elif isinstance(object, BaseServiceMapper):
        write_service(object, out)
    elif isinstance(object, BaseServicedependencyMapper):
        write_servicedependency(object, out)
    elif isinstance(object, BaseServiceescalationMapper):
        write_serviceescalation(object, out)
    elif isinstance(object, BaseServicegroupMapper):
        write_servicegroup(object, out)
    elif isinstance(object, BaseTimeperiodMapper):
        write_timeperiod(object, out)
    else:
        raise ValueError
