from sqlalchemy import Column, Integer, Table, ForeignKey

from nachos.nacoma.api.sqlalchemy.base import Base


contact2contactgroup = \
    Table('contact_contactgroup', Base.metadata,
          Column('contact', Integer, ForeignKey('contact.id')),
          Column('contactgroup', Integer, ForeignKey('contactgroup.id')),
          )


contactgroup2member = \
    Table('contactgroup_members', Base.metadata,
          Column('contactgroup', Integer, ForeignKey('contactgroup.id')),
          Column('members', Integer, ForeignKey('contactgroup.id')),
          )


host2contact = \
    Table('host_contact', Base.metadata,
          Column('host', Integer, ForeignKey('host.id')),
          Column('contact', Integer, ForeignKey('contact.id')),
          )


host2contactgroup = \
    Table('host_contactgroup', Base.metadata,
          Column('host', Integer, ForeignKey('host.id')),
          Column('contactgroup', Integer, ForeignKey('contactgroup.id')),
          )


host2hostgroup = \
    Table('host_hostgroup', Base.metadata,
          Column('host', Integer, ForeignKey('host.id')),
          Column('hostgroup', Integer, ForeignKey('hostgroup.id')),
          )


host2parent = \
    Table('host_parents', Base.metadata,
          Column('host', Integer, ForeignKey('host.id')),
          Column('parents', Integer, ForeignKey('host.id')),
          )


hostescalation2contact = \
    Table('hostescalation_contact', Base.metadata,
          Column('hostescalation', Integer, ForeignKey('hostescalation.id')),
          Column('contact', Integer, ForeignKey('contact.id')),
          )


hostescalation2contactgroup = \
    Table('hostescalation_contactgroup', Base.metadata,
          Column('hostescalation', Integer, ForeignKey('hostescalation.id')),
          Column('contactgroup', Integer, ForeignKey('contactgroup.id')),
          )


hostgroup2member = \
    Table('hostgroup_members', Base.metadata,
          Column('hostgroup', Integer, ForeignKey('hostgroup.id')),
          Column('members', Integer, ForeignKey('hostgroup.id')),
          )


service2contact = \
    Table('service_contact', Base.metadata,
          Column('service', Integer, ForeignKey('service.id')),
          Column('contact', Integer, ForeignKey('contact.id')),
          )


service2contactgroup = \
    Table('service_contactgroup', Base.metadata,
          Column('service', Integer, ForeignKey('service.id')),
          Column('contactgroup', Integer, ForeignKey('contactgroup.id')),
          )


service2servicegroup = \
    Table('service_servicegroup', Base.metadata,
          Column('service', Integer, ForeignKey('service.id')),
          Column('servicegroup', Integer, ForeignKey('servicegroup.id')),
          )


serviceescalation2contact = \
    Table('serviceescalation_contact', Base.metadata,
          Column('serviceescalation',
                 Integer, ForeignKey('serviceescalation.id')),
          Column('contact',
                 Integer, ForeignKey('contact.id')),
          )


serviceescalation2contactgroup = \
    Table('serviceescalation_contactgroup', Base.metadata,
          Column('serviceescalation',
                 Integer, ForeignKey('serviceescalation.id')),
          Column('contactgroup',
                 Integer, ForeignKey('contactgroup.id')),
          )


servicegroup2member = \
    Table('servicegroup_members', Base.metadata,
          Column('servicegroup', Integer, ForeignKey('servicegroup.id')),
          Column('members', Integer, ForeignKey('servicegroup.id')),
          )


timeperiod2exclude = \
    Table('timeperiod_exclude', Base.metadata,
          Column('timeperiod', Integer, ForeignKey('timeperiod.id')),
          Column('exclude', Integer, ForeignKey('timeperiod.id')),
          )
