from abc import abstractmethod
from nachos.nacoma.mappers import BaseMapper


class BaseContactMapper(BaseMapper):

    @property
    @abstractmethod
    def contact_name(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def alias(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def contactgroups(self):
        """
        :return List<BaseContactgroupMapper>|None:
        """
        pass

    @property
    @abstractmethod
    def file(self):
        """
        :return BaseFileMapper|None
        """

    @property
    @abstractmethod
    def minimum_value(self):
        """
        :return float|None:
        """
        pass

    @property
    @abstractmethod
    def host_notifications_enabled(self):
        """
        :return bool|None:
        """
        pass

    @property
    @abstractmethod
    def service_notifications_enabled(self):
        """
        :return bool|None:
        """
        pass

    @property
    @abstractmethod
    def host_notification_timeperiod(self):
        """
        :return BaseTimeperiodMapper|None:
        """
        pass

    @property
    @abstractmethod
    def service_notification_timeperiod(self):
        """
        :return BaseTimeperiodMapper|None:
        """
        pass

    @property
    @abstractmethod
    def host_notification_options(self):
        """
        :return HostNotificationOptions|None:
        """
        pass

    @property
    @abstractmethod
    def service_notification_options(self):
        """
        :return ServiceNotificationOptions|None:
        """
        pass

    @property
    @abstractmethod
    def host_notification_commands(self):
        """
        :return List<string>|None:
        """
        pass

    @property
    @abstractmethod
    def service_notification_commands(self):
        """
        :return List<string>|None:
        """
        pass

    @property
    @abstractmethod
    def email(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def pager(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def address1(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def address2(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def address3(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def address4(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def address5(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def address6(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def can_submit_commands(self):
        """
        :return bool|None:
        """
        pass

    @property
    @abstractmethod
    def retain_status_information(self):
        """
        :return bool|None:
        """
        pass

    @property
    @abstractmethod
    def retain_nonstatus_information(self):
        """
        :return bool|None:
        """
        pass

    @property
    @abstractmethod
    def use(self):
        """
        :return BaseContactMapper|None:
        """
        pass

    @property
    @abstractmethod
    def name(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def register(self):
        """
        :return bool|None:
        """
        pass

    @property
    @abstractmethod
    def hosts(self):
        """
        :return List<BaseHostMapper>:
        """

    @property
    @abstractmethod
    def hostescalations(self):
        """
        :return List<BaseHostescalationMapper>:
        """

    @property
    @abstractmethod
    def services(self):
        """
        :return List<BaseServiceMapper>:
        """

    @property
    @abstractmethod
    def serviceescalations(self):
        """
        :return List<BaseServiceescalationMapper>:
        """
