from abc import abstractmethod
from nachos.nacoma.mappers import BaseMapper


class BaseHostescalationMapper(BaseMapper):

    @property
    @abstractmethod
    def host(self):
        """
        :return BaseHostMapper|None:
        """
        pass

    @property
    @abstractmethod
    def hostgroup(self):
        """
        :return BaseHostgroupMapper|None:
        """
        pass

    @property
    @abstractmethod
    def contacts(self):
        """
        :return List<BaseContactMapper>|None:
        """
        pass

    @property
    @abstractmethod
    def contact_groups(self):
        """
        :return List<BaseContactgroupMapper>|None:
        """
        pass

    @property
    @abstractmethod
    def file(self):
        """
        :return BaseFileMapper|None
        """

    @property
    @abstractmethod
    def first_notification(self):
        """
        :return int|None:
        """
        pass

    @property
    @abstractmethod
    def last_notification(self):
        """
        :return int|None:
        """
        pass

    @property
    @abstractmethod
    def notification_interval(self):
        """
        :return int|None:
        """
        pass

    @property
    @abstractmethod
    def escalation_timeperiod(self):
        """
        :return BaseTimeperiodMapper|None:
        """
        pass

    @property
    @abstractmethod
    def escalation_options(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def name(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def use(self):
        """
        :return BaseHostescalationMapper|None:
        """
        pass

    @property
    @abstractmethod
    def register(self):
        """
        :return bool|None:
        """
        pass
