from abc import abstractmethod
from nachos.nacoma.mappers import BaseMapper


class BaseServicedependencyMapper(BaseMapper):

    @property
    @abstractmethod
    def dependent_host(self):
        """
        :return BaseHostMapper|None:
        """
        pass

    @property
    @abstractmethod
    def dependent_hostgroup(self):
        """
        :return BaseHostgroupMapper|None:
        """
        pass

    @property
    @abstractmethod
    def servicegroup_name(self):
        """
        :return BaseServicegroupMapper|None:
        """
        pass

    @property
    @abstractmethod
    def dependent_servicegroup_name(self):
        """
        :return BaseServicegroupMapper|None:
        """
        pass

    @property
    @abstractmethod
    def dependent_service(self):
        """
        :return BaseServiceMapper|None:
        """
        pass

    @property
    @abstractmethod
    def host(self):
        """
        :return BaseHostMapper|None:
        """
        pass

    @property
    @abstractmethod
    def hostgroup(self):
        """
        :return BaseHostgroupMapper|None:
        """
        pass

    @property
    @abstractmethod
    def file(self):
        """
        :return BaseFileMapper|None
        """

    @property
    @abstractmethod
    def service(self):
        """
        :return BaseServiceMapper|None:
        """
        pass

    @property
    @abstractmethod
    def inherits_parent(self):
        """
        :return bool|None:
        """
        pass

    @property
    @abstractmethod
    def execution_failure_criteria(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def notification_failure_criteria(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def dependency_period(self):
        """
        :return BaseTimeperiodMapper|None:
        """
        pass

    @property
    @abstractmethod
    def name(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def use(self):
        """
        :return BaseServicedependencyMapper|None:
        """
        pass

    @property
    @abstractmethod
    def register(self):
        """
        :return bool|None:
        """
        pass
