from abc import abstractmethod
from nachos.nacoma.mappers import BaseMapper


class BaseServicegroupMapper(BaseMapper):

    @property
    @abstractmethod
    def servicegroup_name(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def alias(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def file(self):
        """
        :return BaseFileMapper|None
        """

    @property
    @abstractmethod
    def members(self):
        """
        :return List<BaseServiceMapper>|None:
        """
        pass

    @property
    @abstractmethod
    def servicegroup_members(self):
        """
        :return List<BaseServicegroupMapper>|None:
        """
        pass

    @property
    @abstractmethod
    def notes(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def notes_url(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def action_url(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def name(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def use(self):
        """
        :return BaseServicegroupMapper|None:
        """
        pass

    @property
    @abstractmethod
    def register(self):
        """
        :return bool|None:
        """
        pass
