from abc import abstractmethod
from nachos.nacoma.mappers import BaseMapper


class BaseTimeperiodMapper(BaseMapper):

    @property
    @abstractmethod
    def timeperiod_name(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def alias(self):
        """
        :return string|None:
        """
        pass

    @property
    @abstractmethod
    def weekdays(self):
        """
        :return List<DateTimeRange>|None:
        """
        pass

    @property
    @abstractmethod
    def exceptions(self):
        """
        :return List<DateTimeRange>|None:
        """
        pass

    @property
    @abstractmethod
    def exclude(self):
        """
        :return List<BaseTimeperiodMapper>|None:
        """
        pass

    @property
    @abstractmethod
    def use(self):
        """
        :return BaseTimeperiodMapper|None:
        """
        pass

    @property
    @abstractmethod
    def register(self):
        """
        :return bool|None:
        """
        pass
