from oslo_config import cfg

from nachos.nacoma.mappers.sqlalchemy.mapper import Mapper
from nachos.nacoma.mappers.base.command import BaseCommandMapper
from nachos.nacoma.mappers.sqlalchemy.file import FileMapper


class CommandMapper(Mapper, BaseCommandMapper):

    @property
    def command_name(self):
        return self.mapattr('command_name')

    @property
    def command_line(self):
        cmd = self.mapattr('command_line')
        if cmd is not None:
            return cmd.decode(cfg.CONF.nacoma.blob_encoding)
        return None

    @property
    def file(self):
        return self.mapattr('file', mapper=FileMapper)

    @property
    def register(self):
        return self.mapattr('register')

    @property
    def changelog_name(self):
        return self.command_name
