from nachos.nacoma.mappers.sqlalchemy.mapper import Mapper
from nachos.nacoma.mappers.base.contactgroup import BaseContactgroupMapper
from nachos.nacoma.mappers.sqlalchemy.file import FileMapper


class ContactgroupMapper(Mapper, BaseContactgroupMapper):

    @property
    def id(self):
        return self.mapattr('id')

    @property
    def contactgroup_name(self):
        return self.mapattr('contactgroup_name')

    @property
    def alias(self):
        return self.mapattr('alias')

    @property
    def file(self):
        return self.mapattr('file', mapper=FileMapper)

    @property
    def members(self):
        from nachos.nacoma.mappers import ContactMapper
        return self.mapattr('contacts', mapper=[ContactMapper])

    @property
    def contactgroup_members(self):
        return self.mapattr('subgroups', mapper=[ContactgroupMapper])

    @property
    def supergroups(self):
        return self.mapattr('supergroups', mapper=[ContactgroupMapper])

    @property
    def hosts(self):
        from nachos.nacoma.mappers import HostMapper
        return self.mapattr('hosts', mapper=[HostMapper])

    @property
    def services(self):
        from nachos.nacoma.mappers import ServiceMapper
        return self.mapattr('services', mapper=[ServiceMapper])

    @property
    def hostescalations(self):
        from nachos.nacoma.mappers import HostescalationMapper
        return self.mapattr('hostescalations', mapper=[HostescalationMapper])

    @property
    def serviceescalations(self):
        from nachos.nacoma.mappers import ServiceescalationMapper
        return self.mapattr(
            'serviceescalations',
            mapper=[ServiceescalationMapper]
        )

    @property
    def dependent_objects(self):
        objects = super().dependent_objects
        objects.update(
            self.hosts,
            self.services,
            self.hostescalations,
            self.serviceescalations,
            self.supergroups
        )
        return objects

    @property
    def changelog_name(self):
        return self.contactgroup_name
