from nachos.nacoma.mappers.sqlalchemy.mapper import Mapper
from nachos.nacoma.mappers.base.hostdependency import BaseHostdependencyMapper
from nachos.nacoma.mappers.sqlalchemy.file import FileMapper
from nachos.nacoma.mappers.sqlalchemy.host import HostMapper
from nachos.nacoma.mappers.sqlalchemy.hostgroup import HostgroupMapper
from nachos.nacoma.mappers.sqlalchemy.timeperiod import TimeperiodMapper


class HostdependencyMapper(Mapper, BaseHostdependencyMapper):

    @property
    def host(self):
        return self.mapattr('host', mapper=HostMapper)

    @property
    def hostgroup(self):
        return self.mapattr('hostgroup', mapper=HostgroupMapper)

    @property
    def dependent_host(self):
        return self.mapattr('dependent_host', mapper=HostMapper)

    @property
    def dependent_hostgroup(self):
        return self.mapattr('dependent_hostgroup', mapper=HostgroupMapper)

    @property
    def dependency_period(self):
        return self.mapattr('dependency_period', mapper=TimeperiodMapper)

    @property
    def file(self):
        return self.mapattr('file', mapper=FileMapper)

    @property
    def inherits_parent(self):
        return self.mapattr('inherits_parent')

    @property
    def execution_failure_criteria(self):
        return self.mapattr('execution_failure_criteria')

    @property
    def notification_failure_criteria(self):
        return self.mapattr('notification_failure_criteria')

    @property
    def use(self):
        return None

    @property
    def name(self):
        return self.mapattr('name')

    @property
    def register(self):
        return self.mapattr('register')
