from nachos.nacoma.mappers.sqlalchemy.mapper import Mapper
from nachos.nacoma.mappers.base.hostgroup import BaseHostgroupMapper
from nachos.nacoma.mappers.sqlalchemy.file import FileMapper


class HostgroupMapper(Mapper, BaseHostgroupMapper):

    @property
    def id(self):
        return self.mapattr('id')

    @property
    def hostgroup_name(self):
        return self.mapattr('hostgroup_name')

    @property
    def alias(self):
        return self.mapattr('alias')

    @property
    def file(self):
        return self.mapattr('file', mapper=FileMapper)

    @property
    def members(self):
        from nachos.nacoma.mappers.sqlalchemy.host import HostMapper
        return self.mapattr('hosts', mapper=[HostMapper])

    @property
    def hostgroup_members(self):
        return self.mapattr('subgroups', mapper=[HostgroupMapper])

    @property
    def supergroups(self):
        return self.mapattr('supergroups', mapper=[HostgroupMapper])

    @property
    def notes(self):
        return self.mapattr('notes')

    @property
    def notes_url(self):
        return self.mapattr('notes_url')

    @property
    def action_url(self):
        return self.mapattr('action_url')

    @property
    def name(self):
        return self.mapattr('name')

    @property
    def use(self):
        return None

    @property
    def register(self):
        return self.mapattr('register')

    @property
    def dependent_objects(self):
        objects = super().dependent_objects
        objects.update(self.members, self.supergroups)
        return objects

    @property
    def changelog_name(self):
        return self.hostgroup_name
