from nachos.nacoma.mappers.sqlalchemy.mapper import Mapper
from nachos.nacoma.mappers.base.servicedependency import BaseServicedependencyMapper  # noqa: E501
from nachos.nacoma.mappers.sqlalchemy.file import FileMapper
from nachos.nacoma.mappers.sqlalchemy.service import ServiceMapper
from nachos.nacoma.mappers.sqlalchemy.timeperiod import TimeperiodMapper


class ServicedependencyMapper(Mapper, BaseServicedependencyMapper):

    @property
    def dependent_host(self):
        dependent_service = self.dependent_service
        return dependent_service.host if dependent_service else None

    @property
    def dependent_hostgroup(self):
        dependent_service = self.dependent_service
        return dependent_service.hostgroup if dependent_service else None

    @property
    def file(self):
        return self.mapattr('file', mapper=FileMapper)

    @property
    def host(self):
        service = self.service
        return service.host if service else None

    @property
    def hostgroup(self):
        service = self.service
        return service.hostgroup if service else None

    @property
    def service(self):
        return self.mapattr('service', mapper=ServiceMapper)

    @property
    def servicegroup_name(self):
        return self.mapattr('servicegroup_name')

    @property
    def dependent_service(self):
        return self.mapattr('dependent_service', mapper=ServiceMapper)

    @property
    def dependent_servicegroup_name(self):
        return self.mapattr('dependent_servicegroup_name')

    @property
    def dependency_period(self):
        return self.mapattr('dependency_period', mapper=TimeperiodMapper)

    @property
    def inherits_parent(self):
        return self.mapattr('inherits_parent')

    @property
    def execution_failure_criteria(self):
        return self.mapattr('execution_failure_criteria')

    @property
    def notification_failure_criteria(self):
        return self.mapattr('notification_failure_criteria')

    @property
    def name(self):
        return self.mapattr('name')

    @property
    def use(self):
        return self.mapattr('template')

    @property
    def register(self):
        return self.mapattr('register')
