from nachos.nacoma.mappers.sqlalchemy.mapper import Mapper
from nachos.nacoma.mappers.base.servicegroup import BaseServicegroupMapper
from nachos.nacoma.mappers.sqlalchemy.file import FileMapper


class ServicegroupMapper(Mapper, BaseServicegroupMapper):

    @property
    def servicegroup_name(self):
        return self.mapattr('name')

    @property
    def alias(self):
        return self.mapattr('alias')

    @property
    def file(self):
        return self.mapattr('file', mapper=FileMapper)

    @property
    def members(self):
        from nachos.nacoma.mappers.sqlalchemy.service import ServiceMapper
        return self.mapattr('services', mapper=[ServiceMapper])

    @property
    def servicegroup_members(self):
        return self.mapattr('subgroups', mapper=[ServicegroupMapper])

    @property
    def supergroups(self):
        return self.mapattr('supergroups', mapper=[ServicegroupMapper])

    @property
    def notes(self):
        return self.mapattr('notes')

    @property
    def notes_url(self):
        return self.mapattr('notes_url')

    @property
    def action_url(self):
        return self.mapattr('action_url')

    @property
    def use(self):
        return self.mapattr('template')

    @property
    def name(self):
        return self.mapattr('name')

    @property
    def register(self):
        return self.mapattr('register')

    @property
    def dependent_objects(self):
        objects = super().dependent_objects
        objects.update(self.members, self.supergroups)
        return objects

    @property
    def changelog_name(self):
        return self.servicegroup_name
