from nachos.nacoma.mappers.sqlalchemy.mapper import Mapper
from nachos.nacoma.consts import DateTimeRange
from nachos.nacoma.mappers.base.timeperiod import BaseTimeperiodMapper
from nachos.nacoma.mappers.sqlalchemy.customvar import CustomvarMapper
from nachos.nacoma.mappers.sqlalchemy.file import FileMapper


class TimeperiodMapper(Mapper, BaseTimeperiodMapper):

    @property
    def timeperiod_name(self):
        return self.mapattr('timeperiod_name')

    @property
    def alias(self):
        return self.mapattr('alias')

    @property
    def file(self):
        return self.mapattr('file', mapper=FileMapper)

    @property
    def weekdays(self):
        weekdays = []
        for day in [
            'monday', 'tuesday', 'wednesday', 'thursday', 'friday',
            'saturday', 'sunday'
        ]:
            time = self.mapattr(day)
            if time is not None:
                weekdays.append(DateTimeRange(day, time))
        if len(weekdays):
            return weekdays
        return None

    @property
    def exceptions(self):
        return self.mapattr('exceptions')

    @property
    def exclude(self):
        return self.mapattr('excluded', mapper=[TimeperiodMapper])

    @property
    def use(self):
        return None

    @property
    def register(self):
        return None

    @property
    def custom_vars(self):
        return self.mapattr('custom_vars', mapper=[CustomvarMapper])

    @property
    def changelog_name(self):
        return self.timeperiod_name
