<?php

# these two objects are present everywhere anything
# actually happens, and some functions rely on them
# being global, so instantiate them here.
require_once('gui_nacoma.php');

global $page;
$page = new gui_nacoma_Model();
global $input;
$input = new input_nacoma_Model();

$max_input_vars_limit = ini_get("max_input_vars");
$request_count = 0;
array_walk_recursive($_REQUEST, function ($val) use (&$request_count) {
    $request_count++;
});

if($request_count >= $max_input_vars_limit) {
    $msg = "Input variables exceeded. To increase the limit change max_input_vars in php.ini
    <br/>For more information on how to resolve this issue, see
    <a href=\"" . Kohana::config('product.support_url', true) . "hc/en-us/articles/360033799154-How-to-Tweak-PHP-and-MySQL-settings-for-OP5-Monitor\" target=\"_BLANK\">
    this article</a>
    <br/>Counted {$request_count} variables, limit is set at {$max_input_vars_limit}";
    deny_access($msg);
}
